//*********************************************************
//
// Copyright (c) Microsoft. All rights reserved.
// This code is licensed under the MIT License (MIT).
// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

#pragma once 
#include "pch.h"

namespace SDKTemplate
{
    value struct Scenario;

    partial ref class MainPage
    {
    internal:
        static property Platform::String^ FEATURE_NAME
        {
            Platform::String^ get()
            {
                return "Accelerometer C# Sample";
            }
        }

        static property Platform::Array<Scenario>^ scenarios
        {
            Platform::Array<Scenario>^ get()
            {
                return scenariosInner;
            }
        }

        static void SetReadingText(Windows::UI::Xaml::Controls::TextBlock^ textBlock, Windows::Devices::Sensors::AccelerometerReading^ reading);

        property Windows::Devices::Sensors::AccelerometerReadingType AccelerometerReadingType
        {
            Windows::Devices::Sensors::AccelerometerReadingType get()
            {
                return accelerometerReadingType;
            }
            void set(Windows::Devices::Sensors::AccelerometerReadingType value)
            {
                accelerometerReadingType = value;
            }
        }

    private:
        static Platform::Array<Scenario>^ scenariosInner;
        Windows::Devices::Sensors::AccelerometerReadingType accelerometerReadingType = Windows::Devices::Sensors::AccelerometerReadingType::Standard;
    };

    public value struct Scenario
    {
        Platform::String^ Title;
        Platform::String^ ClassName;
    };
}
