﻿<!---
  category: Navigation
  samplefwlink: http://go.microsoft.com/fwlink/p/?LinkId=620582
--->

# XHR, handling navigation errors, and URL schemes sample

Shows how to handle navigation errors, how to use the right URL scheme to reference packaged content, and how to use
[XMLHttpRequest](http://msdn.microsoft.com/library/windows/apps/hh453379) (XHR) to retrieve remote and local content.

> **Note:** This sample is part of a large collection of UWP feature samples. 
> If you are unfamiliar with Git and GitHub, you can download the entire collection as a 
> [ZIP file](https://github.com/Microsoft/Windows-universal-samples/archive/master.zip), but be 
> sure to unzip everything to access shared dependencies. For more info on working with the ZIP file, 
> the samples collection, and GitHub, see [Get the UWP samples from GitHub](https://aka.ms/ovu2uq). 
> For more samples, see the [Samples portal](https://aka.ms/winsamples) on the Windows Dev Center. 

For more info about the concepts and APIs demonstrated in this sample, see these topics:

-   [How to reference content](http://msdn.microsoft.com/library/windows/apps/hh781215)
-   [How to link to external web pages](http://msdn.microsoft.com/library/windows/apps/hh780594)
-   [Quickstart: Using single-page navigation](http://msdn.microsoft.com/library/windows/apps/hh452768)
-   [How to create a mashup](http://msdn.microsoft.com/library/windows/apps/hh452745)

This sample is written in HTML, CSS, and JavaScript.

Related topics
--------------

[How to link to external web pages](http://msdn.microsoft.com/library/windows/apps/hh780594)  
[How to reference content](http://msdn.microsoft.com/library/windows/apps/hh781215)  
[Quickstart: Using single-page navigation](http://msdn.microsoft.com/library/windows/apps/hh452768)  

Related technologies
--------------------

[Windows 10 apps using JavaScript](http://msdn.microsoft.com/library/windows/apps/br211385)  

Operating system requirements
-----------------------------

Client

Windows 10

Build the sample
----------------

1. If you download the samples ZIP, be sure to unzip the entire archive, not just the folder with the sample you want to build. 
2. Start Microsoft Visual Studio 2017 and select **File** \> **Open** \> **Project/Solution**.
3. Starting in the folder where you unzipped the samples, go to the Samples subfolder, then the subfolder for this specific sample, then the subfolder for your preferred language (C++, C#, or JavaScript). Double-click the Visual Studio Solution (.sln) file.
4. Press Ctrl+Shift+B, or select **Build** \> **Build Solution**.

Run the sample
--------------

To debug the app and then run it, press F5 or use **Debug** \> **Start Debugging**. To run the app without debugging, press Ctrl+F5 or use **Debug** \> **Start Without Debugging**.

