//*********************************************************
//
// Copyright (c) Microsoft. All rights reserved.
// This code is licensed under the MIT License (MIT).
// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

#pragma once 
#include "pch.h"
#include "ViewLifetimeControl.h"

namespace SDKSample
{
    value struct Scenario;

    partial ref class MainPage
    {
    internal:
        SecondaryViewsHelpers::ViewLifetimeControl^ ProjectionViewPageControl;

        static property Platform::String^ FEATURE_NAME
        {
            Platform::String^ get()
            {
                return "Projection";
            }
        }

        static property Platform::Array<Scenario>^ scenarios
        {
            Platform::Array<Scenario>^ get()
            {
                return scenariosInner;
            }
        }

    private:
        static Platform::Array<Scenario>^ scenariosInner;
    };

    public value struct Scenario
    {
        Platform::String^ Title;
        Platform::String^ ClassName;
    };

    // This is a simple container for a set of data used to initialize the projection view
    [Windows::Foundation::Metadata::WebHostHidden]
    public ref class ProjectionViewPageInitializationData sealed
    {
    internal:
        Windows::UI::Core::CoreDispatcher^ MainDispatcher;
        SecondaryViewsHelpers::ViewLifetimeControl^ ProjectionViewPageControl;
        int MainViewId;
    };

}
