<!---
  category: Surface Dial
-->

# Surface Dial C++ API sample

Shows how to use the Surface Dial API to create custom menu items and control haptic feedback.

> **Note:** This sample is part of a large collection of UWP feature samples. 
> If you are unfamiliar with Git and GitHub, you can download the entire collection as a 
> [ZIP file](https://github.com/Microsoft/Windows-universal-samples/archive/master.zip), but be 
> sure to unzip everything to access shared dependencies. For more info on working with the ZIP file, 
> the samples collection, and GitHub, see [Get the UWP samples from GitHub](https://aka.ms/ovu2uq). 
> For more samples, see the [Samples portal](https://aka.ms/winsamples) on the Windows Dev Center. 

Specifically, this sample shows how to:

- **Add, remove, and select custom items:** This sample demonstrates how to add, remove, and select custom items dynamically using provided or custom icons.
- **Control haptic feedback:** This sample demonstrates how to enable and disable the haptic feedback for custom items.

**Note** The Windows universal samples require Visual Studio 2017 to build and Windows 10 to execute.

To obtain information about Windows 10 development, go to the [Windows Dev Center](http://go.microsoft.com/fwlink/?LinkID=532421)

To obtain information about Microsoft Visual Studio and the tools for developing Windows apps, go to [Visual Studio](http://go.microsoft.com/fwlink/?LinkID=532422)

## Related topics

### Samples

[C# Sample](../cs)  

### Reference

[Radial Controller](https://msdn.microsoft.com/library/windows/apps/Windows.UI.Input.RadialController.aspx)  
[Radial Controller Menu](https://msdn.microsoft.com/library/windows/apps/windows.ui.input.radialcontrollermenu.aspx)  
[Radial Controller Menu Item](https://msdn.microsoft.com/library/windows/apps/Windows.UI.Input.RadialControllerMenuItem.aspx)  
[Radial Controller Configuration](https://msdn.microsoft.com/library/windows/apps/windows.ui.input.radialcontrollerconfiguration.aspx)  

## System requirements

**Client:** Windows 10

## Build the sample

1. If you download the samples ZIP, be sure to unzip the entire archive, not just the folder with the sample you want to build. 
2. Start Microsoft Visual Studio 2017 and select **File** \> **Open** \> **Samples/RadialController/cpp/RadialControllerCXX.sln**.
3. Starting in the folder where you unzipped the samples, go to the Samples subfolder, then the subfolder for this specific sample, then the subfolder for your preferred language (C++ or C#). Double-click the Visual Studio Solution (.sln) file.
4. Press Ctrl+Shift+B, or select **Build** \> **Build Solution**.

## Run the sample

The next steps depend on whether you just want to deploy the sample or you want to both deploy and run it.

### Deploying the sample

- Select Build > Deploy Solution. 

### Deploying and running the sample

- To debug the sample and then run it, press F5 or select Debug >  Start Debugging. To run the sample without debugging, press Ctrl+F5 or selectDebug > Start Without Debugging. 
